/*
 * J2ME Compass
 * Copyright (C) 2006 Dana Peters
 * http://www.qcontinuum.org/compass
 * 
 * Changed 2009 by Vedran Vidovic.
 * Removed henson.midp.Float class for performance reasons.
 * Removed code unused by SgTimer.
 */

package org.qcontinuum.astro;



public class Astrometric {
    public Astrometric() {
    }
    
    public static EclipticPosition sunPosition(double MJD)
    {
        // T = (MJD - MJD_J2000) / 36525.0;
        double T = (MJD - 51544.5) / 36525;
        // Mean anomaly and ecliptic longitude
        // M  = pi2 * Float.Frac(0.993133 + 99.997361 * T); 
        double a = 0.993133 + 99.997361 * T;
        a = a - Math.floor(a);
        double M  = Math.PI * 2 * a; 
        double b =
          0.7859453 + M / (Math.PI * 2) + (6893.0 * Math.sin(M) + 72.0 * Math.sin(2.0 * M) + 6191.2 * T) / 1296.0e3;
        b = b - Math.floor(b);
        double lonSun = Math.PI * 2 * b;
        return new EclipticPosition(0, lonSun);
    }
}
